/* naph_pbtk_pde_model.c for R deSolve package
   ___________________________________________________

   Model File:  naph_pbtk_pde.model

   Date:  Fri Jun 05 18:29:37 2020

   Created by:  "C:/Users/dkapraun/ONEDRI~1/DOCUME~1/MCSIM_~1/mod/mod.exe v6.1.0"
    -- a model preprocessor by Don Maszle
   ___________________________________________________

   Copyright (c) 1993-2019 Free Software Foundation, Inc.

   Model calculations for compartmental model:

   62 States:
     RIV = 0.0,
     AIV = 0.0,
     CIN = 0.0,
     AWELL = 0.0,
     CSC01 = 0.0,
     CSC02 = 0.0,
     CSC03 = 0.0,
     CSC04 = 0.0,
     CSC05 = 0.0,
     CSC06 = 0.0,
     CSC07 = 0.0,
     CSC08 = 0.0,
     CSC09 = 0.0,
     ADERM = 0.0,
     ALDR = 0.0,
     AMTDR = 0.0,
     ATDR = 0.0,
     AXDR = 0.0,
     ALDO1 = 0.0,
     AMTO1 = 0.0,
     ATDO1 = 0.0,
     AXDO1 = 0.0,
     ALDO2 = 0.0,
     AMTO2 = 0.0,
     ATDO2 = 0.0,
     AXDO2 = 0.0,
     ALVR1 = 0.0,
     AMTV1 = 0.0,
     ATVR1 = 0.0,
     AXVR1 = 0.0,
     ALVR2 = 0.0,
     AMTV2 = 0.0,
     ATVR2 = 0.0,
     AXVR2 = 0.0,
     ALPL = 0.0,
     ATPL = 0.0,
     AXPL = 0.0,
     ALCA = 0.0,
     ATCA = 0.0,
     AXCA = 0.0,
     AMLPU = 0.0,
     ATPU = 0.0,
     AML = 0.0,
     ALI = 0.0,
     AFA = 0.0,
     ARP = 0.0,
     APP = 0.0,
     AVE = 0.0,
     AAB = 0.0,
     AVB = 0.0,
     AIN = 0.0,
     AUC_CAB_UG = 0.0,
     AUC_CTDO_UG = 0.0,
     CMTDO_UG = 0.0,
     AUC_CMTDO_UG = 0.0,
     AUC_RCMTDO_UG = 0.0,
     CMBODY_UG = 0.0,
     AUC_CMBODY_UG = 0.0,
     AUC_RCMBODY_UG = 0.0,
     CTDOALT_UG = 0.0,
     AUC_CTDOALT_UG = 0.0,
     AUC_RDELDO_UG = 0.0,

   47 Outputs:
    "ASC",
    "CWELL",
    "CSC00",
    "CSC10",
    "CLDR",
    "CTDR",
    "CXDR",
    "CLDO1",
    "CTDO1",
    "CXDO1",
    "CLDO2",
    "CTDO2",
    "CXDO2",
    "CLVR1",
    "CTVR1",
    "CXVR1",
    "CURT",
    "CLPL",
    "CTPL",
    "CXPL",
    "CLCA",
    "CTCA",
    "CXCA",
    "CLPU",
    "CTPU",
    "CvTPU",
    "CLI",
    "CvLI",
    "CFA",
    "CvFA",
    "CRP",
    "CvRP",
    "CPP",
    "CvPP",
    "CVE",
    "CvVE",
    "CAB",
    "CVB",
    "CAB_UG",
    "JSC00",
    "JSC10",
    "AINa",
    "CTDO",
    "CTDO_UG",
    "RCMTDO_UG",
    "RCMBODY_UG",
    "RDELDO_UG",

   0 Inputs:

   147 Parameters:
     AEXP = 0.0,
     VWELL = 1.0,
     BWinit = 315,
     QPUc = 1.756,
     MVc = 1.909,
     DSC = 1.0e-8,
     TSC = 0.003,
     TVE = 0.0075,
     FBURT = 0.0015,
     FBLI = 0.25,
     FBFA = 0.07,
     FBPP = 0.1675,
     FBRP = 0.5,
     FBCA = 0.011,
     FTLI = 0.037,
     FFAT = 0.065,
     FTPP = 0.5618,
     FTRP = 0.178,
     FTABD = 0.018,
     FTVBD = 0.045,
     FTREM = 0.09,
     HBA = 571.0,
     HTB = 3.49,
     HLUB = 1.71,
     HLB = 1.61,
     HFB = 49.0,
     HRPB = 2.12,
     HPPB = 3.49,
     HVEB = 2.73,
     HSCVE = 1.98,
     HSCJP8 = 1.0,
     SADR = 0.2,
     SADO1 = 0.42,
     SADO2 = 6.33,
     SAVR1 = 1.8,
     SAVR2 = 4.5,
     SAPL = 1.5,
     SACA = 48.0,
     SAPU = 3000.0,
     WTDR = 0.005,
     WTDO = 0.005,
     WTVR = 0.005,
     WTPL = 0.005,
     WTCA = 0.005,
     WTPU = 0.0004,
     WMUCUS = 0.001,
     WXDR = 0.002,
     WXDO = 0.002,
     WXVR = 0.002,
     WXPL = 0.002,
     WXCA = 0.002,
     VLDR = 0.004,
     VLDO1 = 0.012,
     VLDO2 = 0.054,
     VLVR1 = 0.09,
     VLVR2 = 0.09,
     VLPL = 0.06,
     VLCA = 0.53,
     KGDR = 8000.0,
     KGDO1 = 7167.0,
     KGDO2 = 26667.0,
     KGVR1 = 34680.0,
     KGVR2 = 183333.0,
     KGPL = 5000.0,
     KGCA = 225.0,
     DIFU = 4.5e-4,
     MW1 = 128.17,
     PPMtoNMPML = 0.04,
     VmaxLI = 21.8,
     KmLI = 6.0,
     VmaxLU = 3.8,
     KmLU = 40.0,
     VmaxO = 169.8,
     KmO = 70.0,
     VmaxV = 43.5,
     KmV = 11.5,
     FADR = 0.15,
     FADO = 0.15,
     FAVR = 0.85,
     VTDR = 0.0,
     VTDO1 = 0.0,
     VTDO2 = 0.0,
     VTVR1 = 0.0,
     VTVR2 = 0.0,
     VTPL = 0.0,
     VTCA = 0.0,
     VTPU = 0.0,
     VXDR = 0.0,
     VXDO1 = 0.0,
     VXDO2 = 0.0,
     VXVR1 = 0.0,
     VXVR2 = 0.0,
     VXPL = 0.0,
     VXCA = 0.0,
     VTLUNG = 0.0,
     SAURT = 0.0,
     VTLI = 0.0,
     VFAT = 0.0,
     VTSC = 0.0,
     VTVE = 0.0,
     VTRP = 0.0,
     VTPP = 0.0,
     VTAB = 0.0,
     VTVB = 0.0,
     VTREM = 0.0,
     SCDX = 0.0,
     BW = 0.0,
     MV = 0.0,
     VPU = 0.0,
     VDR = 0.0,
     VDO = 0.0,
     VVR = 0.0,
     QPUa = 0.0,
     FBDR = 0.0,
     FBDO1 = 0.0,
     FBDO2 = 0.0,
     FBVR1 = 0.0,
     FBVR2 = 0.0,
     FBPL = 0.0,
     QDR = 0.0,
     QDO1 = 0.0,
     QDO2 = 0.0,
     QVR1 = 0.0,
     QVR2 = 0.0,
     QPL = 0.0,
     QCA = 0.0,
     QLI = 0.0,
     QVE = 0.0,
     QRP = 0.0,
     QPP = 0.0,
     QFA = 0.0,
     QPU = 0.0,
     HTA = 0.0,
     MTCDR = 0.0,
     MTCDO1 = 0.0,
     MTCDO2 = 0.0,
     MTCVR1 = 0.0,
     MTCVR2 = 0.0,
     MTCPL = 0.0,
     MTCCA = 0.0,
     KTXDR = 0.0,
     KTXDO1 = 0.0,
     KTXDO2 = 0.0,
     KTXVR1 = 0.0,
     KTXVR2 = 0.0,
     KTXPL = 0.0,
     KTXCA = 0.0,
*/

#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include <R_ext/Rdynload.h>

/* Model variables: States */
#define ID_RIV 0x00000
#define ID_AIV 0x00001
#define ID_CIN 0x00002
#define ID_AWELL 0x00003
#define ID_CSC01 0x00004
#define ID_CSC02 0x00005
#define ID_CSC03 0x00006
#define ID_CSC04 0x00007
#define ID_CSC05 0x00008
#define ID_CSC06 0x00009
#define ID_CSC07 0x0000a
#define ID_CSC08 0x0000b
#define ID_CSC09 0x0000c
#define ID_ADERM 0x0000d
#define ID_ALDR 0x0000e
#define ID_AMTDR 0x0000f
#define ID_ATDR 0x00010
#define ID_AXDR 0x00011
#define ID_ALDO1 0x00012
#define ID_AMTO1 0x00013
#define ID_ATDO1 0x00014
#define ID_AXDO1 0x00015
#define ID_ALDO2 0x00016
#define ID_AMTO2 0x00017
#define ID_ATDO2 0x00018
#define ID_AXDO2 0x00019
#define ID_ALVR1 0x0001a
#define ID_AMTV1 0x0001b
#define ID_ATVR1 0x0001c
#define ID_AXVR1 0x0001d
#define ID_ALVR2 0x0001e
#define ID_AMTV2 0x0001f
#define ID_ATVR2 0x00020
#define ID_AXVR2 0x00021
#define ID_ALPL 0x00022
#define ID_ATPL 0x00023
#define ID_AXPL 0x00024
#define ID_ALCA 0x00025
#define ID_ATCA 0x00026
#define ID_AXCA 0x00027
#define ID_AMLPU 0x00028
#define ID_ATPU 0x00029
#define ID_AML 0x0002a
#define ID_ALI 0x0002b
#define ID_AFA 0x0002c
#define ID_ARP 0x0002d
#define ID_APP 0x0002e
#define ID_AVE 0x0002f
#define ID_AAB 0x00030
#define ID_AVB 0x00031
#define ID_AIN 0x00032
#define ID_AUC_CAB_UG 0x00033
#define ID_AUC_CTDO_UG 0x00034
#define ID_CMTDO_UG 0x00035
#define ID_AUC_CMTDO_UG 0x00036
#define ID_AUC_RCMTDO_UG 0x00037
#define ID_CMBODY_UG 0x00038
#define ID_AUC_CMBODY_UG 0x00039
#define ID_AUC_RCMBODY_UG 0x0003a
#define ID_CTDOALT_UG 0x0003b
#define ID_AUC_CTDOALT_UG 0x0003c
#define ID_AUC_RDELDO_UG 0x0003d

/* Model variables: Outputs */
#define ID_ASC 0x00000
#define ID_CWELL 0x00001
#define ID_CSC00 0x00002
#define ID_CSC10 0x00003
#define ID_CLDR 0x00004
#define ID_CTDR 0x00005
#define ID_CXDR 0x00006
#define ID_CLDO1 0x00007
#define ID_CTDO1 0x00008
#define ID_CXDO1 0x00009
#define ID_CLDO2 0x0000a
#define ID_CTDO2 0x0000b
#define ID_CXDO2 0x0000c
#define ID_CLVR1 0x0000d
#define ID_CTVR1 0x0000e
#define ID_CXVR1 0x0000f
#define ID_CURT 0x00010
#define ID_CLPL 0x00011
#define ID_CTPL 0x00012
#define ID_CXPL 0x00013
#define ID_CLCA 0x00014
#define ID_CTCA 0x00015
#define ID_CXCA 0x00016
#define ID_CLPU 0x00017
#define ID_CTPU 0x00018
#define ID_CvTPU 0x00019
#define ID_CLI 0x0001a
#define ID_CvLI 0x0001b
#define ID_CFA 0x0001c
#define ID_CvFA 0x0001d
#define ID_CRP 0x0001e
#define ID_CvRP 0x0001f
#define ID_CPP 0x00020
#define ID_CvPP 0x00021
#define ID_CVE 0x00022
#define ID_CvVE 0x00023
#define ID_CAB 0x00024
#define ID_CVB 0x00025
#define ID_CAB_UG 0x00026
#define ID_JSC00 0x00027
#define ID_JSC10 0x00028
#define ID_AINa 0x00029
#define ID_CTDO 0x0002a
#define ID_CTDO_UG 0x0002b
#define ID_RCMTDO_UG 0x0002c
#define ID_RCMBODY_UG 0x0002d
#define ID_RDELDO_UG 0x0002e

/* Parameters */
static double parms[147];

#define AEXP parms[0]
#define VWELL parms[1]
#define BWinit parms[2]
#define QPUc parms[3]
#define MVc parms[4]
#define DSC parms[5]
#define TSC parms[6]
#define TVE parms[7]
#define FBURT parms[8]
#define FBLI parms[9]
#define FBFA parms[10]
#define FBPP parms[11]
#define FBRP parms[12]
#define FBCA parms[13]
#define FTLI parms[14]
#define FFAT parms[15]
#define FTPP parms[16]
#define FTRP parms[17]
#define FTABD parms[18]
#define FTVBD parms[19]
#define FTREM parms[20]
#define HBA parms[21]
#define HTB parms[22]
#define HLUB parms[23]
#define HLB parms[24]
#define HFB parms[25]
#define HRPB parms[26]
#define HPPB parms[27]
#define HVEB parms[28]
#define HSCVE parms[29]
#define HSCJP8 parms[30]
#define SADR parms[31]
#define SADO1 parms[32]
#define SADO2 parms[33]
#define SAVR1 parms[34]
#define SAVR2 parms[35]
#define SAPL parms[36]
#define SACA parms[37]
#define SAPU parms[38]
#define WTDR parms[39]
#define WTDO parms[40]
#define WTVR parms[41]
#define WTPL parms[42]
#define WTCA parms[43]
#define WTPU parms[44]
#define WMUCUS parms[45]
#define WXDR parms[46]
#define WXDO parms[47]
#define WXVR parms[48]
#define WXPL parms[49]
#define WXCA parms[50]
#define VLDR parms[51]
#define VLDO1 parms[52]
#define VLDO2 parms[53]
#define VLVR1 parms[54]
#define VLVR2 parms[55]
#define VLPL parms[56]
#define VLCA parms[57]
#define KGDR parms[58]
#define KGDO1 parms[59]
#define KGDO2 parms[60]
#define KGVR1 parms[61]
#define KGVR2 parms[62]
#define KGPL parms[63]
#define KGCA parms[64]
#define DIFU parms[65]
#define MW1 parms[66]
#define PPMtoNMPML parms[67]
#define VmaxLI parms[68]
#define KmLI parms[69]
#define VmaxLU parms[70]
#define KmLU parms[71]
#define VmaxO parms[72]
#define KmO parms[73]
#define VmaxV parms[74]
#define KmV parms[75]
#define FADR parms[76]
#define FADO parms[77]
#define FAVR parms[78]
#define VTDR parms[79]
#define VTDO1 parms[80]
#define VTDO2 parms[81]
#define VTVR1 parms[82]
#define VTVR2 parms[83]
#define VTPL parms[84]
#define VTCA parms[85]
#define VTPU parms[86]
#define VXDR parms[87]
#define VXDO1 parms[88]
#define VXDO2 parms[89]
#define VXVR1 parms[90]
#define VXVR2 parms[91]
#define VXPL parms[92]
#define VXCA parms[93]
#define VTLUNG parms[94]
#define SAURT parms[95]
#define VTLI parms[96]
#define VFAT parms[97]
#define VTSC parms[98]
#define VTVE parms[99]
#define VTRP parms[100]
#define VTPP parms[101]
#define VTAB parms[102]
#define VTVB parms[103]
#define VTREM parms[104]
#define SCDX parms[105]
#define BW parms[106]
#define MV parms[107]
#define VPU parms[108]
#define VDR parms[109]
#define VDO parms[110]
#define VVR parms[111]
#define QPUa parms[112]
#define FBDR parms[113]
#define FBDO1 parms[114]
#define FBDO2 parms[115]
#define FBVR1 parms[116]
#define FBVR2 parms[117]
#define FBPL parms[118]
#define QDR parms[119]
#define QDO1 parms[120]
#define QDO2 parms[121]
#define QVR1 parms[122]
#define QVR2 parms[123]
#define QPL parms[124]
#define QCA parms[125]
#define QLI parms[126]
#define QVE parms[127]
#define QRP parms[128]
#define QPP parms[129]
#define QFA parms[130]
#define QPU parms[131]
#define HTA parms[132]
#define MTCDR parms[133]
#define MTCDO1 parms[134]
#define MTCDO2 parms[135]
#define MTCVR1 parms[136]
#define MTCVR2 parms[137]
#define MTCPL parms[138]
#define MTCCA parms[139]
#define KTXDR parms[140]
#define KTXDO1 parms[141]
#define KTXDO2 parms[142]
#define KTXVR1 parms[143]
#define KTXVR2 parms[144]
#define KTXPL parms[145]
#define KTXCA parms[146]

/* Forcing (Input) functions */
static double forc[0];


/* Function definitions for delay differential equations */

int Nout=1;
int nr[1]={0};
double ytau[1] = {0.0};

static double yini[62] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}; /*Array of initial state variables*/

void lagvalue(double T, int *nr, int N, double *ytau) {
  static void(*fun)(double, int*, int, double*) = NULL;
  if (fun == NULL)
    fun = (void(*)(double, int*, int, double*))R_GetCCallable("deSolve", "lagvalue");
  return fun(T, nr, N, ytau);
}

double CalcDelay(int hvar, double dTime, double delay) {
  double T = dTime-delay;
  if (dTime > delay){
    nr[0] = hvar;
    lagvalue( T, nr, Nout, ytau );
}
  else{
    ytau[0] = yini[hvar];
}
  return(ytau[0]);
}

/*----- Initializers */
void initmod (void (* odeparms)(int *, double *))
{
  int N=147;
  odeparms(&N, parms);
}

void initforc (void (* odeforcs)(int *, double *))
{
  int N=0;
  odeforcs(&N, forc);
}


/* Calling R code will ensure that input y has same
   dimension as yini */
void initState (double *y)
{
  int i;

  for (i = 0; i < sizeof(yini) / sizeof(yini[0]); i++)
  {
    yini[i] = y[i];
  }
}

void getParms (double *inParms, double *out, int *nout) {
/*----- Model scaling */

  int i;

  for (i = 0; i < *nout; i++) {
    parms[i] = inParms[i];
  }


  VTDR = SADR * WTDR ;
  VTDO1 = SADO1 * WTDO ;
  VTDO2 = SADO2 * WTDO ;
  VTVR1 = SAVR1 * WTVR ;
  VTVR2 = SAVR2 * WTVR ;
  VTPL = SAPL * WTVR ;
  VTCA = SACA * WTCA ;
  VTPU = SAPU * WTPU ;

  VXDR = SADR * WXDR ;
  VXDO1 = SADO1 * WXDO ;
  VXDO2 = SADO2 * WXDO ;
  VXVR1 = SAVR1 * WXVR ;
  VXVR2 = SAVR2 * WXVR ;
  VXPL = SAPL * WXVR ;
  VXCA = SACA * WXCA ;

  VTLUNG = VTDR + VTDO1 + VTDO2 + VTVR1 + VTVR2 + VTPL + VTCA + VTPU + VXDR + VXDO1 + VXDO2 + VXVR1 + VXVR2 + VXPL + VXCA ;

  SAURT = SADR + SADO1 + SADO2 + SAVR1 + SAVR2 + SAPL ;

  VTLI = FTLI * BWinit ;
  VFAT = FFAT * BWinit ;
  VTSC = AEXP * TSC ;
  VTVE = AEXP * TVE ;
  VTRP = FTRP * BWinit - VTVE ;
  VTPP = FTPP * BWinit ;
  VTAB = FTABD * BWinit ;
  VTVB = FTVBD * BWinit ;
  VTREM = FTREM * BWinit ;

  SCDX = TSC / 10 ;

  BW = VTLI + VFAT + VTRP + VTPP + VTAB + VTVB + VTLUNG + VTREM + VTVE ;

  MV = MVc * pow ( BW , 0.75 ) ;

  VPU = 0.67 * MV ;
  VDR = FADR * MV ;
  VDO = FADO * MV ;
  VVR = FAVR * MV ;

  QPUa = QPUc * pow ( BW , 0.75 ) ;

  FBDR = ( SADR / SAURT ) * FBURT ;
  FBDO1 = ( SADO1 / SAURT ) * FBURT ;
  FBDO2 = ( SADO2 / SAURT ) * FBURT ;
  FBVR1 = ( SAVR1 / SAURT ) * FBURT ;
  FBVR2 = ( SAVR2 / SAURT ) * FBURT ;
  FBPL = ( SAPL / SAURT ) * FBURT ;

  QDR = FBDR * QPUa ;
  QDO1 = FBDO1 * QPUa ;
  QDO2 = FBDO2 * QPUa ;
  QVR1 = FBVR1 * QPUa ;
  QVR2 = FBVR2 * QPUa ;
  QPL = FBPL * QPUa ;
  QCA = FBCA * QPUa ;
  QLI = FBLI * QPUa ;
  QVE = FBRP * ( VTVE / VTRP ) * QPUa ;
  QRP = FBRP * QPUa - QVE ;
  QPP = FBPP * QPUa ;
  QFA = FBFA * QPUa ;

  QPU = QDR + QDO1 + QDO2 + QVR1 + QVR2 + QPL + QCA + QLI + QVE + QRP + QPP + QFA ;

  HTA = HBA * HTB ;

  MTCDR = 1 / ( 1 / KGDR + 1 / ( ( DIFU / ( WMUCUS + 0.5 * WTDR ) ) * HTA ) ) ;

  MTCDO1 = 1 / ( 1 / KGDO1 + 1 / ( ( DIFU / ( WMUCUS + 0.5 * WTDO ) ) * HTA ) ) ;

  MTCDO2 = 1 / ( 1 / KGDO2 + 1 / ( ( DIFU / ( WMUCUS + 0.5 * WTDO ) ) * HTA ) ) ;

  MTCVR1 = 1 / ( 1 / KGVR1 + 1 / ( ( DIFU / ( WMUCUS + 0.5 * WTVR ) ) * HTA ) ) ;

  MTCVR2 = 1 / ( 1 / KGVR2 + 1 / ( ( DIFU / ( WMUCUS + 0.5 * WTVR ) ) * HTA ) ) ;

  MTCPL = 1 / ( 1 / KGPL + 1 / ( ( DIFU / ( WMUCUS + 0.5 * WTPL ) ) * HTA ) ) ;

  MTCCA = 1 / ( 1 / KGCA + 1 / ( ( DIFU / ( WMUCUS + 0.5 * WTCA ) ) * HTA ) ) ;

  KTXDR = DIFU * SADR / ( WTDR / 2 + WXDR / 2 ) ;
  KTXDO1 = DIFU * SADO1 / ( WTDO / 2 + WXDO / 2 ) ;
  KTXDO2 = DIFU * SADO2 / ( WTDO / 2 + WXDO / 2 ) ;
  KTXVR1 = DIFU * SAVR1 / ( WTVR / 2 + WXVR / 2 ) ;
  KTXVR2 = DIFU * SAVR2 / ( WTVR / 2 + WXVR / 2 ) ;
  KTXPL = DIFU * SAPL / ( WTPL / 2 + WXPL / 2 ) ;
  KTXCA = DIFU * SACA / ( WTCA / 2 + WXCA / 2 ) ;

  for (i = 0; i < *nout; i++) {
    out[i] = parms[i];
  }
  }
/*----- Dynamics section */

void derivs (int *neq, double *pdTime, double *y, double *ydot, double *yout, int *ip)
{
  /* local */ double CLVR2;
  /* local */ double CTVR2;
  /* local */ double CXVR2;
  /* local */ double FCTDR;
  /* local */ double FCXDR;
  /* local */ double FCTDO1;
  /* local */ double FCXDO1;
  /* local */ double FCTDO2;
  /* local */ double FCXDO2;
  /* local */ double FCTVR1;
  /* local */ double FCXVR1;
  /* local */ double FCTVR2;
  /* local */ double FCXVR2;
  /* local */ double FCTPL;
  /* local */ double FCXPL;
  /* local */ double FCTCA;
  /* local */ double FCXCA;
  /* local */ double RADERM;
  /* local */ double RALDR;
  /* local */ double RMTDR;
  /* local */ double RATDR;
  /* local */ double RAXDR;
  /* local */ double RALDO1;
  /* local */ double RMTO1;
  /* local */ double RATDO1;
  /* local */ double RAXDO1;
  /* local */ double RALDO2;
  /* local */ double RMTO2;
  /* local */ double RATDO2;
  /* local */ double RAXDO2;
  /* local */ double RALVR1;
  /* local */ double RMTV1;
  /* local */ double RATVR1;
  /* local */ double RAXVR1;
  /* local */ double RALVR2;
  /* local */ double RMTV2;
  /* local */ double RATVR2;
  /* local */ double RAXVR2;
  /* local */ double RALPL;
  /* local */ double RATPL;
  /* local */ double RAXPL;
  /* local */ double RALCA;
  /* local */ double RATCA;
  /* local */ double RAXCA;
  /* local */ double RMLPU;
  /* local */ double RATPU;
  /* local */ double RML;
  /* local */ double RALI;
  /* local */ double RAFA;
  /* local */ double RARP;
  /* local */ double RAPP;
  /* local */ double RAVE;
  /* local */ double RAAB;
  /* local */ double RAVB;
  /* local */ double RAIN;

  yout[ID_CLDR] = y[ID_ALDR] / VLDR ;

  yout[ID_CTDR] = y[ID_ATDR] / VTDR ;

  yout[ID_CXDR] = y[ID_AXDR] / VXDR ;

  yout[ID_CLDO1] = y[ID_ALDO1] / VLDO1 ;

  yout[ID_CTDO1] = y[ID_ATDO1] / VTDO1 ;

  yout[ID_CXDO1] = y[ID_AXDO1] / VXDO1 ;

  yout[ID_CLDO2] = y[ID_ALDO2] / VLDO2 ;

  yout[ID_CTDO2] = y[ID_ATDO2] / VTDO2 ;

  yout[ID_CXDO2] = y[ID_AXDO2] / VXDO2 ;

  yout[ID_CLVR1] = y[ID_ALVR1] / VLVR1 ;

  yout[ID_CTVR1] = y[ID_ATVR1] / VTVR1 ;

  yout[ID_CXVR1] = y[ID_AXVR1] / VXVR1 ;

  CLVR2 = y[ID_ALVR2] / VLVR2 ;

  CTVR2 = y[ID_ATVR2] / VTVR2 ;

  CXVR2 = y[ID_AXVR2] / VXVR2 ;

  yout[ID_CURT] = ( VVR * CLVR2 + VDO * yout[ID_CLDO2] ) / ( VVR + VDO ) ;

  yout[ID_CLPL] = y[ID_ALPL] / VLPL ;

  yout[ID_CTPL] = y[ID_ATPL] / VTPL ;

  yout[ID_CXPL] = y[ID_AXPL] / VXPL ;

  yout[ID_CLCA] = y[ID_ALCA] / VLCA ;

  yout[ID_CTCA] = y[ID_ATCA] / VTCA ;

  yout[ID_CXCA] = y[ID_AXCA] / VXCA ;

  yout[ID_CTPU] = y[ID_ATPU] / VTPU ;

  yout[ID_CvTPU] = yout[ID_CTPU] / HLUB ;

  yout[ID_CLPU] = yout[ID_CvTPU] / HBA ;

  yout[ID_CLI] = y[ID_ALI] / VTLI ;

  yout[ID_CvLI] = yout[ID_CLI] / HLB ;

  yout[ID_CFA] = y[ID_AFA] / VFAT ;

  yout[ID_CvFA] = yout[ID_CFA] / HFB ;

  yout[ID_CRP] = y[ID_ARP] / VTRP ;

  yout[ID_CvRP] = yout[ID_CRP] / HRPB ;

  yout[ID_CPP] = y[ID_APP] / VTPP ;

  yout[ID_CvPP] = yout[ID_CPP] / HPPB ;

  yout[ID_CAB] = y[ID_AAB] / VTAB ;

  yout[ID_CVB] = y[ID_AVB] / VTVB ;

  yout[ID_CVE] = VTVE > 0 ? y[ID_AVE] / VTVE : 0.0 ;

  yout[ID_CvVE] = yout[ID_CVE] / HVEB ;

  yout[ID_CWELL] = VWELL > 0 ? y[ID_AWELL] / VWELL : 0.0 ;

  yout[ID_CSC00] = VWELL > 0 ? yout[ID_CWELL] * HSCJP8 : y[ID_CSC01] ;

  yout[ID_CSC10] = yout[ID_CVE] * HSCVE ;

  yout[ID_CAB_UG] = ( yout[ID_CAB] * MW1 ) / 1000 ;

  FCTDR = yout[ID_CTDR] / HTB ;

  FCXDR = yout[ID_CXDR] / HTB ;

  FCTDO1 = yout[ID_CTDO1] / HTB ;

  FCXDO1 = yout[ID_CXDO1] / HTB ;

  FCTDO2 = yout[ID_CTDO2] / HTB ;

  FCXDO2 = yout[ID_CXDO2] / HTB ;

  FCTVR1 = yout[ID_CTVR1] / HTB ;

  FCXVR1 = yout[ID_CXVR1] / HTB ;

  FCTVR2 = CTVR2 / HTB ;

  FCXVR2 = CXVR2 / HTB ;

  FCTPL = yout[ID_CTPL] / HTB ;

  FCXPL = yout[ID_CXPL] / HTB ;

  FCTCA = yout[ID_CTCA] / HTB ;

  FCXCA = yout[ID_CXCA] / HTB ;

  yout[ID_ASC] = SCDX * ( 0.5 * yout[ID_CSC00] + y[ID_CSC01] + y[ID_CSC02] + y[ID_CSC03] + y[ID_CSC04] + y[ID_CSC05] + y[ID_CSC06] + y[ID_CSC07] + y[ID_CSC08] + y[ID_CSC09] + 0.5 * yout[ID_CSC10] ) * AEXP ;

  yout[ID_JSC00] = - DSC * ( y[ID_CSC01] - yout[ID_CSC00] ) / SCDX ;

  yout[ID_JSC10] = - DSC * ( yout[ID_CSC10] - y[ID_CSC09] ) / SCDX ;

  ydot[ID_RIV] = 0.0 ;

  ydot[ID_AIV] = y[ID_RIV] ;

  ydot[ID_CIN] = 0.0 ;

  RADERM = yout[ID_JSC00] * AEXP ;

  ydot[ID_ADERM] = RADERM ;

  RALDR = VDR * ( y[ID_CIN] - yout[ID_CLDR] ) - MTCDR * SADR * ( yout[ID_CLDR] - yout[ID_CTDR] / HTA ) ;

  ydot[ID_ALDR] = RALDR ;

  RMTDR = VTDR * VmaxO * FCTDR / ( KmO + FCTDR ) ;

  ydot[ID_AMTDR] = RMTDR ;

  RATDR = MTCDR * SADR * ( yout[ID_CLDR] - yout[ID_CTDR] / HTA ) - KTXDR * ( FCTDR - FCXDR ) - RMTDR ;

  ydot[ID_ATDR] = RATDR ;

  RAXDR = KTXDR * ( FCTDR - FCXDR ) - QDR * ( yout[ID_CXDR] / HTB - yout[ID_CAB] ) ;

  ydot[ID_AXDR] = RAXDR ;

  RALDO1 = VDO * ( yout[ID_CLDR] - yout[ID_CLDO1] ) - MTCDO1 * SADO1 * ( yout[ID_CLDO1] - yout[ID_CTDO1] / HTA ) ;

  ydot[ID_ALDO1] = RALDO1 ;

  RMTO1 = VTDO1 * VmaxO * FCTDO1 / ( KmO + FCTDO1 ) ;

  ydot[ID_AMTO1] = RMTO1 ;

  RATDO1 = MTCDO1 * SADO1 * ( yout[ID_CLDO1] - yout[ID_CTDO1] / HTA ) - KTXDO1 * ( FCTDO1 - FCXDO1 ) - RMTO1 ;

  ydot[ID_ATDO1] = RATDO1 ;

  RAXDO1 = KTXDO1 * ( FCTDO1 - FCXDO1 ) - QDO1 * ( yout[ID_CXDO1] / HTB - yout[ID_CAB] ) ;

  ydot[ID_AXDO1] = RAXDO1 ;

  RALDO2 = VDO * ( yout[ID_CLDO1] - yout[ID_CLDO2] ) - MTCDO2 * SADO2 * ( yout[ID_CLDO2] - yout[ID_CTDO2] / HTA ) ;

  ydot[ID_ALDO2] = RALDO2 ;

  RMTO2 = VTDO2 * VmaxO * FCTDO2 / ( KmO + FCTDO2 ) ;

  ydot[ID_AMTO2] = RMTO2 ;

  RATDO2 = MTCDO2 * SADO2 * ( yout[ID_CLDO2] - yout[ID_CTDO2] / HTA ) - KTXDO2 * ( FCTDO2 - FCXDO2 ) - RMTO2 ;

  ydot[ID_ATDO2] = RATDO2 ;

  RAXDO2 = KTXDO2 * ( FCTDO2 - FCXDO2 ) - QDO2 * ( yout[ID_CXDO2] / HTB - yout[ID_CAB] ) ;

  ydot[ID_AXDO2] = RAXDO2 ;

  RALVR1 = VVR * ( y[ID_CIN] - yout[ID_CLVR1] ) - MTCVR1 * SAVR1 * ( yout[ID_CLVR1] - yout[ID_CTVR1] / HTA ) ;

  ydot[ID_ALVR1] = RALVR1 ;

  RMTV1 = VTVR1 * VmaxV * FCTVR1 / ( KmV + FCTVR1 ) ;

  ydot[ID_AMTV1] = RMTV1 ;

  RATVR1 = MTCVR1 * SAVR1 * ( yout[ID_CLVR1] - yout[ID_CTVR1] / HTA ) - KTXVR1 * ( FCTVR1 - FCXVR1 ) - RMTV1 ;

  ydot[ID_ATVR1] = RATVR1 ;

  RAXVR1 = KTXVR1 * ( FCTVR1 - FCXVR1 ) - QVR1 * ( yout[ID_CXVR1] / HTB - yout[ID_CAB] ) ;

  ydot[ID_AXVR1] = RAXVR1 ;

  RALVR2 = VVR * ( yout[ID_CLVR1] - CLVR2 ) - MTCVR2 * SAVR2 * ( CLVR2 - CTVR2 / HTA ) ;

  ydot[ID_ALVR2] = RALVR2 ;

  RMTV2 = VTVR2 * VmaxV * FCTVR2 / ( KmV + FCTVR2 ) ;

  ydot[ID_AMTV2] = RMTV2 ;

  RATVR2 = MTCVR2 * SAVR2 * ( CLVR2 - CTVR2 / HTA ) - KTXVR2 * ( FCTVR2 - FCXVR2 ) - RMTV2 ;

  ydot[ID_ATVR2] = RATVR2 ;

  RAXVR2 = KTXVR2 * ( FCTVR2 - FCXVR2 ) - QVR2 * ( CXVR2 / HTB - yout[ID_CAB] ) ;

  ydot[ID_AXVR2] = RAXVR2 ;

  RALPL = MV * ( yout[ID_CURT] - yout[ID_CLPL] ) - MTCPL * SAPL * ( yout[ID_CLPL] - yout[ID_CTPL] / HTA ) ;

  ydot[ID_ALPL] = RALPL ;

  RATPL = MTCPL * SAPL * ( yout[ID_CLPL] - yout[ID_CTPL] / HTA ) - KTXPL * ( FCTPL - FCXPL ) ;

  ydot[ID_ATPL] = RATPL ;

  RAXPL = KTXPL * ( FCTPL - FCXPL ) - QPL * ( yout[ID_CXPL] / HTB - yout[ID_CAB] ) ;

  ydot[ID_AXPL] = RAXPL ;

  RALCA = MV * ( yout[ID_CLPL] - yout[ID_CLCA] ) - MTCCA * SACA * ( yout[ID_CLCA] - yout[ID_CTCA] / HTA ) ;

  ydot[ID_ALCA] = RALCA ;

  RATCA = - KTXCA * ( FCTCA - FCXCA ) + MTCCA * SACA * ( yout[ID_CLCA] - yout[ID_CTCA] / HTA ) ;

  ydot[ID_ATCA] = RATCA ;

  RAXCA = KTXCA * ( FCTCA - FCXCA ) - QCA * ( yout[ID_CXCA] / HTB - yout[ID_CAB] ) ;

  ydot[ID_AXCA] = RAXCA ;

  RMLPU = VTPU * VmaxLU * yout[ID_CvTPU] / ( KmLU + yout[ID_CvTPU] ) ;

  ydot[ID_AMLPU] = RMLPU ;

  RATPU = VPU * ( yout[ID_CLCA] - yout[ID_CLPU] ) - QPU * ( yout[ID_CvTPU] - yout[ID_CVB] ) - RMLPU ;

  ydot[ID_ATPU] = RATPU ;

  RML = VTLI * VmaxLI * yout[ID_CvLI] / ( KmLI + yout[ID_CvLI] ) ;

  ydot[ID_AML] = RML ;

  RALI = QLI * ( yout[ID_CAB] - yout[ID_CvLI] ) - RML ;

  ydot[ID_ALI] = RALI ;

  RAFA = QFA * ( yout[ID_CAB] - yout[ID_CvFA] ) ;

  ydot[ID_AFA] = RAFA ;

  RARP = QRP * ( yout[ID_CAB] - yout[ID_CvRP] ) ;

  ydot[ID_ARP] = RARP ;

  RAPP = QPP * ( yout[ID_CAB] - yout[ID_CvPP] ) ;

  ydot[ID_APP] = RAPP ;

  ydot[ID_AWELL] = - yout[ID_JSC00] * AEXP ;

  ydot[ID_CSC01] = DSC * ( yout[ID_CSC00] - 2 * y[ID_CSC01] + y[ID_CSC02] ) / ( SCDX * SCDX ) ;

  ydot[ID_CSC02] = DSC * ( y[ID_CSC01] - 2 * y[ID_CSC02] + y[ID_CSC03] ) / ( SCDX * SCDX ) ;

  ydot[ID_CSC03] = DSC * ( y[ID_CSC02] - 2 * y[ID_CSC03] + y[ID_CSC04] ) / ( SCDX * SCDX ) ;

  ydot[ID_CSC04] = DSC * ( y[ID_CSC03] - 2 * y[ID_CSC04] + y[ID_CSC05] ) / ( SCDX * SCDX ) ;

  ydot[ID_CSC05] = DSC * ( y[ID_CSC04] - 2 * y[ID_CSC05] + y[ID_CSC06] ) / ( SCDX * SCDX ) ;

  ydot[ID_CSC06] = DSC * ( y[ID_CSC05] - 2 * y[ID_CSC06] + y[ID_CSC07] ) / ( SCDX * SCDX ) ;

  ydot[ID_CSC07] = DSC * ( y[ID_CSC06] - 2 * y[ID_CSC07] + y[ID_CSC08] ) / ( SCDX * SCDX ) ;

  ydot[ID_CSC08] = DSC * ( y[ID_CSC07] - 2 * y[ID_CSC08] + y[ID_CSC09] ) / ( SCDX * SCDX ) ;

  ydot[ID_CSC09] = DSC * ( y[ID_CSC08] - 2 * y[ID_CSC09] + yout[ID_CSC10] ) / ( SCDX * SCDX ) ;

  RAVE = yout[ID_JSC10] * AEXP + QVE * ( yout[ID_CAB] - yout[ID_CvVE] ) ;

  ydot[ID_AVE] = RAVE ;

  RAAB = QPU * ( yout[ID_CvTPU] - yout[ID_CAB] ) ;

  ydot[ID_AAB] = RAAB ;

  RAVB = QLI * yout[ID_CvLI] + QFA * yout[ID_CvFA] + QRP * yout[ID_CvRP] + QPP * yout[ID_CvPP] + QCA * yout[ID_CXCA] / HTB + QPL * yout[ID_CXPL] / HTB + QVR1 * yout[ID_CXVR1] / HTB + QVR2 * CXVR2 / HTB + QDO1 * yout[ID_CXDO1] / HTB + QDO2 * yout[ID_CXDO2] / HTB + QDR * yout[ID_CXDR] / HTB + QVE * yout[ID_CvVE] - QPU * yout[ID_CVB] + y[ID_RIV] ;

  ydot[ID_AVB] = RAVB ;

  ydot[ID_AUC_CAB_UG] = yout[ID_CAB_UG] ;

  yout[ID_CTDO] = ( y[ID_ATDO1] + y[ID_ATDO2] ) / ( VTDO1 + VTDO2 ) ;

  yout[ID_CTDO_UG] = ( yout[ID_CTDO] * MW1 ) / 1000 ;

  ydot[ID_AUC_CTDO_UG] = yout[ID_CTDO_UG] ;

  ydot[ID_CMTDO_UG] = ( RMTO1 + RMTO2 ) * ( MW1 / 1000 ) / ( VTDO1 + VTDO2 ) - y[ID_CMTDO_UG] * 1.0 * pow ( VTDO1 + VTDO2 , 0.75 ) ;

  ydot[ID_AUC_CMTDO_UG] = y[ID_CMTDO_UG] ;

  yout[ID_RCMTDO_UG] = ( RMTO1 + RMTO2 ) * ( MW1 / 1000 ) / ( VTDO1 + VTDO2 ) ;

  ydot[ID_AUC_RCMTDO_UG] = yout[ID_RCMTDO_UG] ;

  ydot[ID_CMBODY_UG] = ( RMTDR + RMTO1 + RMTO2 + RMTV1 + RMTV2 + RMLPU + RML ) * ( MW1 / 1000 ) / BW - y[ID_CMBODY_UG] * 1.0 * pow ( BW , 0.75 ) ;

  ydot[ID_AUC_CMBODY_UG] = y[ID_CMBODY_UG] ;

  yout[ID_RCMBODY_UG] = ( RMTDR + RMTO1 + RMTO2 + RMTV1 + RMTV2 + RMLPU + RML ) * ( MW1 / 1000 ) / BW ;

  ydot[ID_AUC_RCMBODY_UG] = yout[ID_RCMBODY_UG] ;

  ydot[ID_CTDOALT_UG] = ( MTCDO1 * SADO1 * ( yout[ID_CLDO1] - yout[ID_CTDO1] / HTA ) + MTCDO2 * SADO2 * ( yout[ID_CLDO2] - yout[ID_CTDO2] / HTA ) ) * ( MW1 / 1000 ) / ( VTDO1 + VTDO2 ) - y[ID_CTDOALT_UG] * 1.0 * pow ( VTDO1 + VTDO2 , 0.75 ) ;

  ydot[ID_AUC_CTDOALT_UG] = y[ID_CTDOALT_UG] ;

  yout[ID_RDELDO_UG] = ( MTCDO1 * SADO1 * ( yout[ID_CLDO1] - yout[ID_CTDO1] / HTA ) + MTCDO2 * SADO2 * ( yout[ID_CLDO2] - yout[ID_CTDO2] / HTA ) ) * ( MW1 / 1000 ) / ( SADO1 + SADO2 ) ;

  ydot[ID_AUC_RDELDO_UG] = yout[ID_RDELDO_UG] ;

  RAIN = MV * ( y[ID_CIN] - yout[ID_CLCA] ) + VPU * ( yout[ID_CLCA] - yout[ID_CLPU] ) + y[ID_RIV] + RADERM ;

  ydot[ID_AIN] = RAIN ;

  yout[ID_AINa] = y[ID_ALDR] + y[ID_ATDR] + y[ID_AXDR] + y[ID_AMTDR] + y[ID_ALDO1] + y[ID_ATDO1] + y[ID_AXDO1] + y[ID_AMTO1] + y[ID_ALDO2] + y[ID_ATDO2] + y[ID_AXDO2] + y[ID_AMTO2] + y[ID_ALVR1] + y[ID_ATVR1] + y[ID_AXVR1] + y[ID_AMTV1] + y[ID_ALVR2] + y[ID_ATVR2] + y[ID_AXVR2] + y[ID_AMTV2] + y[ID_ALPL] + y[ID_ATPL] + y[ID_AXPL] + y[ID_ALCA] + y[ID_ATCA] + y[ID_AXCA] + y[ID_ATPU] + y[ID_AMLPU] + y[ID_AAB] + y[ID_AVB] + y[ID_ALI] + y[ID_AML] + y[ID_AFA] + y[ID_ARP] + y[ID_APP] + yout[ID_ASC] + y[ID_AVE] ;

} /* derivs */


/*----- Jacobian calculations: */
void jac (int *neq, double *t, double *y, int *ml, int *mu, double *pd, int *nrowpd, double *yout, int *ip)
{

} /* jac */


/*----- Events calculations: */
void event (int *n, double *t, double *y)
{

} /* event */

/*----- Roots calculations: */
void root (int *neq, double *t, double *y, int *ng, double *gout, double *out, int *ip)
{

} /* root */

